gabriel_website_2/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include(('main.urls', 'main'), namespace='main')),
]

main/urls.py
from django.urls import path

from . import views

app_name = 'main'

urlpatterns = [
    path('', views.home, name='home'),
    path('story1', views.story1, name="story1"),
    path('simplified', views.simplified, name="simplified"),
    path('detailed', views.detailed, name="detailed"),
    path('matkul', views.matkul, name="matkul"),
    path('matkul/<int:id>', views.view_matkul),
    path('add_matkul', views.add_matkul, name="add_matkul"),
    path('hapus_matkul/<int:id>', views.hapus_matkul, name="hapus_matkul")
]

main/models.py
from django.db import models

# Create your models here.
class MataKuliah(models.Model):
    nama = models.CharField(max_length=50)
    semester_tahun = models.CharField(max_length=20)
    dosen = models.CharField(max_length=50)
    sks = models.DecimalField(decimal_places=0, max_digits=1)
    ruang_kelas = models.CharField(max_length=50)
    deskripsi = models.TextField(max_length=100)

class HapusMatkul(models.Model):
    nama = models.CharField(max_length=50)

main/forms.py
from django import forms
from .models import MataKuliah, HapusMatkul

class MataKuliahForm(forms.ModelForm):
    class Meta:
        model = MataKuliah
        fields = ["nama", "semester_tahun", "dosen", "sks", "ruang_kelas", "deskripsi"]

    error_messages = {
        "required" : "Please Type"
    }

    input_attrs = {
        "nama" : {
            "type" : "text",
            "placeholder" : "PPW"
        },

        "semester tahun" : {
            "type" : "text",
            "placeholder" : "Gasal 2020/2021",
            "pattern" : "(Gasal|Genap) 20\d{2}\/20\d{2}"
        },

        "dosen" : {
            "type" : "text",
            "placeholder" : "Iis Afriyanti"
        },

        "sks" : {
            "type" : "number",
            "placeholder" : "3"
        },

        "ruang kelas" : {
            "type" : "text",
            "placeholder" : "A1.08 (Ged Baru)"
        },

        "desc" : {
            "placeholder" : "Write description here"
        }         
    }

    nama = forms.CharField(label="Nama Mata Kuliah", required=True, widget=forms.TextInput(attrs=input_attrs["nama"]))
    semester_tahun = forms.CharField(label="Semester / Tahun", required=True, widget=forms.TextInput(attrs=input_attrs["semester tahun"]))
    dosen = forms.CharField(label="Nama Dosen", required=True, widget=forms.TextInput(attrs=input_attrs["dosen"]))
    sks = forms.DecimalField(label="Jumlah SKS", required=True, widget=forms.TextInput(attrs=input_attrs["sks"]))
    ruang_kelas = forms.CharField(label="Ruang Kelas", required=True, widget=forms.TextInput(attrs=input_attrs["ruang kelas"]))
    deskripsi = forms.CharField(label="Deskripsi Singkat", required=True, widget=forms.Textarea(attrs=input_attrs["desc"]))



class HapusForm(forms.ModelForm):
    class Meta:
        model = HapusMatkul
        fields = ["nama"]

    error_messages = {
        "required" : "Please Type"
    }

    input_attrs = {
        "nama" : {
            "type" : "text",
            "placeholder" : "PPW"
        }       
    }

    nama = forms.CharField(label="Nama Mata Kuliah", required=True, widget=forms.TextInput(attrs=input_attrs["nama"]))

main/views.py
from django.shortcuts import render
from django.http import HttpResponseRedirect
from .forms import MataKuliahForm, HapusForm
from .models import MataKuliah, HapusMatkul


def home(request):
    return render(request, 'main/home.html')

def story1(request):
    return render(request, 'main/story1.html')

def simplified(request):
    return render(request, 'main/simplified.html')

def detailed(request): 
    return render(request, 'main/detailed.html')

def matkul(request): 
    matkuls = MataKuliah.objects.all()
    response = {"matkuls" : matkuls}
    return render(request, 'main/matkul.html', response)

def view_matkul(request, id):
    matkul = MataKuliah.objects.get(id=id)
    response = {'matkul' : matkul}
    return render(request, 'main/view_matkul.html', response)

def add_matkul(request):
    response = {
        "form" : MataKuliahForm,
        'pesan' : ''
    }

    if request.method == "POST":
        form = MataKuliahForm(request.POST or None)
        if form.is_valid():
            form.save()
            response['pesan'] = 'Mata Kuliah berhasil ditambahkan'
            return render(request, 'main/add_matkul.html', response)
        else:
            response['pesan'] = 'Mata Kuliah gagal ditambahkan. Pastikan format masukkan sudah benar'
            return render(request, 'main/add_matkul.html', response)

    return render(request, 'main/add_matkul.html', response)
    
def hapus_matkul(request, id):
    matkul = MataKuliah.objects.get(id=id)
    matkul.delete()
    return HttpResponseRedirect("/matkul")

main/templates/main/add_matkul.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>Gabriel Website - Mata Kuliah</title>
{% endblock meta %}

{% block content %}
<div class="matkul-form">
    <form action="add_matkul" method="POST">
        {% csrf_token %}
        {{ form.as_p }}
        <input type="submit" value="Submit"> {{ pesan }}
    </form>
</div>
{% endblock content %}

main/templates/main/detailed.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>Gabriel Website - Detailed</title>
{% endblock meta %}

{% block content %}
<div class="content-wrapper">
    <div class="section-header-profpic"><img class="profile-picture-2" src="{% static 'img/profpic-2-small.JPG' %}" alt="Profile Picture"></div>
    <div class="section-wrapper">
        <div class="one-line"><b>Gabriel Enrique</b></div>
        <div class="one-line">Computer Science Student</div>
        <br>
        <div class="one-line">
            Gabriel Enrique, born in 2001, in the capital city of Indonesia, Jakarta.
            His parents worked in the technology department as an IT Manager, he soon took
            interest in technology shortly. Ever since, he started to explore further. He first knew
            programing when he was in 10<sup>th</sup> grade. From there on, he got really interested
            in programing. He progress further into the world of programing when he got accepted
            to the Faculty of Computer Science Universitas Indonesia. He has made up his mind
            to pursue his programing journey.
        </div>
    </div>
</div>

<div class="content-wrapper">
    <div class="section-header"><div><b>Profile</b></div></div>
    <div class="section-wrapper">
        <div class="split-colums">
            <div>2001</div>
            <div>Born in Jakarta</div>
        </div>
        <div class="split-colums">
            <div>2016</div>
            <div>Starts high school education at Al Jabr Islamic School</div>
        </div>

        <div class="split-colums">
            <div>2017</div>
            <div>IB Personal Project: Communicating with Technology using 21<sup>st</sup> Century Language</div>
        </div>

        <div class="split-colums">
            <div></div>
            <div>Leader of I'm SURE Movement at Kepulauan Seribu, Indonesia</div>
        </div>

        <div class="split-colums">
            <div>-18</div>
            <div>President of the Student Council</div>
        </div>

        <div class="split-colums">
            <div>2018</div>
            <div>Project Officer for Perayaan Hari Bahasa</div>
        </div>

        <div class="split-colums">
            <div>2019</div>
            <div>Graduated from Al Jabr Islamic School</div>
        </div>

        <br>

        <div class="split-colums">
            <div>2019</div>
            <div>Starts university education at Faculty of Computer Science Universitas Indonesia</div>
        </div>

        <div class="split-colums">
            <div></div>
            <div>Joins OSUI Mahawaditra as a Violinist</div>
        </div>

        <div class="split-colums">
            <div>2020</div>
            <div>RISTEK Data Science junior member</div>
        </div>

        <div class="split-colums">
            <div></div>
            <div>Bibliography staff at OSUI Mahawaditra</div>
        </div>

        <div class="split-colums">
            <div></div>
            <div>Teaching assistant for DDP-1</div>
        </div>
    </div>
</div>

<div class="content-wrapper">
    <div class="section-header"><div><b>Skills and Hobbies</b></div></div>
    <div class="section-wrapper">
        <div class="one-line"><b>Programing Languages</b></div>
        <div class="one-line">Python</div>
        <div class="one-line">Java</div>
        <div class="one-line">JavaScript</div>
        <div class="one-line">HTML and CSS</div>

        <br>

        <div class="one-line"><b>Soft skills</b></div>
        <div class="one-line">Critical Thinker</div>
        <div class="one-line">Keen Learner</div>
        <div class="one-line">Problem Solving</div>

        <br>

        <div class="one-line"><b>Projects</b></div>
        <div class="one-line">BashBot</div>
        <div class="one-line">BudayaKB Lite</div>

        <br>

        <div class="one-line"><b>Hobbies and Interests</b></div>
        <div class="one-line">Aranging and playing music</div>
        <div class="one-line">Wrting and reading various kinds of literatures</div>
        <div class="one-line">Filming and watching movies</div>
    </div>
</div>

<div class="content-wrapper">
    <div class="section-header"><div><b>Contact</b></div></div>
    <div class="section-wrapper">
        <div class="one-line"><b>Email</b></div>
        <div class="one-line">gabrielenrique.abel@gmail.com</div>

        <br>

        <div class="one-line"><b>Github</b></div>
        <div class="one-line"><a class="links" href="https://github.com/gabriel-enrique">gabriel-enrique</a></div>

        <br>

        <div class="one-line"><b>Gitlab</b></div>
        <div class="one-line"><a class="links" href="https://gitlab.com/gabriel.enrique">gabriel.enrique</a></div>

        <br>

        <div class="one-line"><b>LinkedIn</b></div>
        <div class="one-line"><a class="links" href="https://www.linkedin.com/in/gabriel-enrique-399360194/">View profile</a></div>

        <br>

        <div class="one-line"><b>Instagram</b></div>
        <div class="one-line">@gabriel_enrique19</div>

    </div>
</div>
{% endblock content %}

main/templates/main/hapus_matkul.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>Gabriel Website - Mata Kuliah</title>
{% endblock meta %}

{% block content %}
<form action="hapus_matkul" method="POST">
    {% csrf_token %}
    {{ form.as_p }}
    <input type="submit" value="Submit">
</form>

{{ pesan }}
{% endblock content %}

main/templates/main/home.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>Gabriel Website</title>
{% endblock meta %}

{% block content %}
<div class="welcome-prompt">
    <h1 style="font-size: 50px;">Welcome to my Website!</h1>
    <p style="font-size: 25px;">Click Simplified for a simplified look or Detailed for a detailed overview to get started</p>
    <p style="font-size: 25px;">You can also click Story 1 to view this website 1<sup>st</sup> version</p>
</div>
{% endblock content %}

main/templates/main/matkul.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>Gabriel Website - Mata Kuliah</title>
{% endblock meta %}

{% block content %}
<div class="matkul-container">
    {% if matkuls %}
        {% for matkul in matkuls %}
            <div class="matkul">
                <h2>{{ matkul.nama }}</h2>
                <a class="detail" href="matkul/{{ matkul.id }}">Detail</a>
                <a class="delete" href="hapus_matkul/{{ matkul.id }}">Delete</a>
            </div>
        {% endfor %}
    {% elif not matkuls %}
        <h1 id="matkul-notfound" style="font-size: 25px;">Belum ada mata kuliah</h1>
    {% endif %}
</div>
{% endblock content %}

main/templates/main/simplified.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>Gabriel Website - Simplified</title>
{% endblock meta %}

{% block content %}
<div class="container">
    <!-- Row 1 -->
    <div class="card-row">
        <!-- Card 1: Name -->
        <div class="card-container">
            <div class="card">
                <figure class="front">
                    <h1>What is my name?</h1>
                </figure>
                <figure class="back">
                    <p class=content>Hi, my name is</p>
                    <p class=content style="font-size: 150%;"><b>Gabriel Enrique</b></p>
                </figure>
            </div>
        </div>

        <!-- Card 2: Profile Picture -->
        <div class="card-container">
            <div class="card">
                <figure class="front">
                    <h1>What do I look like?</h1>
                </figure>
                <figure class="back">
                    <img class="profile-picture" src="{% static 'img/profpic.JPG' %}" alt="Profile picture">
                </figure>
            </div>
        </div>

        <!-- Card 3: About Me -->
        <div class="card-container">
            <div class="card">
                <figure class="front">
                    <h1>About me?</h1>
                </figure>
                <figure class="back">
                    <p class=content>I have a <b>high interest</b> towards the realm of <b>technology</b></p>
                </figure>
            </div>
        </div>
    </div>

    <!-- Row 2 -->
    <div class="card-row">
        <!-- Card 4: Educational  Background -->
        <div class="card-container">
            <div class="card">
                <figure class="front">
                    <h1>Where do I study?</h1>
                </figure>
                <figure class="back">
                    <p class=content style="font-size: 130%;"><b>Fakultas Ilmu Komputer</b></p>
                    <p class=content style="font-size: 100%;">Universitas Indonesia</p>
                </figure>p
            </div>
        </div>

        <!-- Card 5: Academic Skills-->
        <div class="card-container">
            <div class="card">
                <figure class="front">
                    <h1>What are my skills?</h1>
                </figure>
                <figure class="back">
                    <p class=content>Fluent in <b>Python</b> and <b>Java</b></p>
                    <p class=content>Currently learning <b>HTML</b>, <b>CSS</b> and <b>JavaScript</b></p>
                </figure>
            </div>
        </div>

        <!-- Card 6: Non-academic Skills -->
        <div class="card-container">
            <div class="card">
                <figure class="front">
                    <h1>Any other skills?</h1>
                </figure>
                <figure class="back">
                    <p class=content>I’m a <b>critical thinker</b> and a <b>keen learner</b></p>
                    <p class=content>I also like <b>problem solving</b></p>
                </figure>
            </div>
        </div>
    </div>

    <!-- Row 3 -->
    <div class="card-row">
        <!-- Card 7: Experiences -->
        <div class="card-container">
            <div class="card">
                <figure class="front">
                    <h1>Any experiences?</h1>
                </figure>
                <figure class="back">
                    <p class=content><b>Teaching Asistant</b> for <b>DDP 1</b></p>
                    <p class=content>Junior Member at <b>RISTEK Data Science</b></p>
                </figure>
            </div>
        </div>

        <!-- Card 8: Hobby -->
        <div class="card-container">
            <div class="card">
                <figure class="front">
                    <h1>Do I have hobbies?</h1>
                </figure>
                <figure class="back">
                    <p class=content>Enjoys <b>music</b> and <b>literature</b></p>
                    <p class=content>Appreciates good <b>movies</b> and <b>film</b></p>
                </figure>
            </div>
        </div>

        <!-- Card 9: Contacts -->
        <div class="card-container">
            <div class="card">
                <figure class="front">
                    <h1>How can you contact me?</h1>
                </figure>
                <figure class="back">
                    <!-- LinkedIn -->
                    <p class=contacts><img class="logo" src="{% static 'img/linkedinlogo.png' %}" alt="LinkedIn"> <a class="links" href="https://www.linkedin.com/in/gabriel-enrique-399360194/">LinkedIn</a></p>
                
                    <!-- GitHub -->
                    <p class=contacts><img class="logo" src="{% static 'img/githublogo.png' %}" alt="GitHub"> <a class="links" href="https://github.com/gabriel-enrique">GitHub</a></p>

                    <!-- GitLab -->
                    <p class=contacts><img class="logo" src="{% static 'img/gitlablogo.png' %}" alt="GitLab"> <a class="links" href="https://gitlab.com/gabriel.enrique">GitLab</a></p>
                </figure>
            </div>
        </div>
    </div>
</div>
{% endblock content %}

main/templates/main/story1.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>Gabriel Website - Story 1</title>
{% endblock meta %}

{% block content %}
<div align="center">
    <table align="center">
        <tr>
            <th colspan="2" style="font-size: xx-large;">Gabriel Enrique</th>
            <td rowspan="5"><img style="border-top-right-radius: 25px; margin: 5px;" src="{% static 'img/profpic_story1.JPG' %}" alt="Profile picture" width="150"></td>
        </tr>

        <tr>
            <th align="right">NPM</th>
            <td>1906293032</td>
        </tr>

        <tr>
            <th align="right">Tempat Kuliah</th>
            <td>Fasilkom UI</td>
        </tr>

        <tr>
            <th align="right">Angkatan</th>
            <td>Maung 2019</td>
        </tr>

        <tr>
            <th align="right">Pendidikan Sebelumnya</th>
            <td>Al Jabr Islamic School</td>
        </tr>

        <tr>
            <th colspan="3" align="left">About Me</th>
        </tr>

        <tr>
            <td colspan="3" width="100px" >Halo semua! Perkenalkan, saya Gabriel Enrique. Seperti yang bisa kalian lihat, saya kuliah di Fasilkom Universitas Indonesia jurusan Ilmu Komputer. Ini website pertama saya. Salam kenal semuanya!</td>
        </tr>
    </table>
</div>

<div align="center">
    <table align="center">
        <tr>
            <th align="left">Hobi</th>
            <td width="10px"></td>
            <th align="left">Media Sosial</th>
        </tr>

        <tr>
            <td>Musik</td>
            <td width="10px"></td>
            <td><img src="{% static 'img/linelogo.png' %}" alt="LINE" width="20" style="vertical-align:middle"> gabrielvillarin</td>
        </tr>

        <tr>
            <td>Game</td>
            <td width="10px"></td>
            <td><img src="{% static 'img/instagramlogo.png' %}" alt="Instagram" width="20" style="vertical-align:middle"> @gabriel_enrique19</td>
        </tr>

        <tr>
            <td>Komputer</td>
            <td width="10px"></td>
            <td><img src="{% static 'img/githublogo.png' %}" alt="Github" width="20" style="vertical-align:middle"><a class="links" href="https://github.com/gabriel-enrique"> Github Profile</a></td>
        </tr>

        <tr>
            <td>Film</td>
            <td width="10px"></td>
            <td><img src="{% static 'img/gitlablogo.png' %}" alt="Gitlab" width="20" style="vertical-align:middle"><a class="links" href="https://gitlab.com/gabriel.enrique"> Gitlab Profile</a></td>
        </tr>
    </table>
</div>
{% endblock content %}

main/templates/main/view_matkul.html
{% extends 'base.html' %}
{% load static %}

{% block meta %}
<title>Gabriel Website - Mata Kuliah</title>
{% endblock meta %}

{% block content %}
<div class="content-wrapper">
    <div class="section-header"><div><b>{{ matkul.nama }}</b></div></div>
    <div class="section-wrapper">
        <div class="one-line"><b>Semester / Tahun</b></div>
        <div class="one-line">{{ matkul.semester_tahun }}</div>

        <br>

        <div class="one-line"><b>Dosen</b></div>
        <div class="one-line">{{ matkul.dosen }}</div>

        <br>

        <div class="one-line"><b>SKS</b></div>
        <div class="one-line">{{ matkul.sks }}</div>

        <br>

        <div class="one-line"><b>Ruang Kelas</b></div>
        <div class="one-line">{{ matkul.ruang_kelas }}</div>
        
        <br>

        <div class="one-line"><b>Deskripsi</b></div>
        <div class="one-line">{{ matkul.deskripsi }}</div>

        <br>

        <div class="one-line"><a class="back-button" href="{% url 'main:matkul' %}">Back</a></div>
    </div>
</div>
{% endblock content %}

templates/base.html
{% load static %}
<!DOCTYPE html>

<html lang="en">
    <head>
        <meta charset="UTF-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <link rel="stylesheet" href="{% static 'css/style.css' %}">
        {% block meta %}
        {% endblock meta %}
    </head>

    <body>
        <!-- Navbar -->
        <nav class="navbar">
            <ul>
                <li><a href="{% url 'main:home' %}">Home</a></li>
                <li><a href="{% url 'main:simplified' %}">Simplified</a></li>
                <li><a href="{% url 'main:detailed' %}">Detailed</a></li>
                <li><a href="{% url 'main:story1' %}">Story 1</a></li>
                <li><a href="{% url 'main:matkul' %}">Mata Kuliah</a></li>
                <li><a href="{% url 'main:add_matkul' %}">Add Mata Kuliah</a></li>
            </ul>
        </nav>

        {% block content %}
        {% endblock content %}
    </body>
</html>